## ball 1.4.1+20111206

=== CMakeLists.txt ===
# CMake configuration for BALL (http://www.ball-project.org)
#
# This file is - on purpose - heavily based on the CMake configuration
# of OpenMS (http://www.openms.de) to optimize synergy effects

PROJECT("BALL")

# TODO LIST:
#   BALL specific:
#
#   inherited from OpenMS:
#			- test for contrib headers (CONTRIB_HEADER_DIR ccmake variable - test one header for each required library)
#			- parallel build of test executables
#			- target to execute all EXAMPLES

########################################################
### entries meant to be configured using CMake cache ###
### - do NOT hardcode them here!										 ###
### - edit them within CMakeCache.txt using ccmake	 ###
########################################################
# CONTRIB_CUSTOM_DIR
# STL_DEBUG
# QT_DB_PLUGIN
# MT_CUDA_BUILD_TYPE

########################################################
###    manual entries (edit this for new release)    ###
########################################################

SET(BALL_PACKAGE_VERSION_MAJOR "1")
SET(BALL_PACKAGE_VERSION_MINOR "4")
SET(BALL_PACKAGE_VERSION_PATCH "1")

########################################################
###    end manual	entries													   ###
########################################################

# Heart of the BUILD system : only edit when you know what you�re doing (we don�t)
# quick manual for most commands: http://www.cmake.org/cmake/help/cmake2.6docs.html
# useful predefined variables: http://www.paraview.org/Wiki/CMake_Useful_Variables

CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)

SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

SET(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE TRUE)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

OPTION(BALL_USE_PROJECT_FOLDERS ON)
IF (BALL_USE_PROJECT_FOLDERS)
	SET(USE_FOLDERS TRUE)
ENDIF()

SET(CF_BALL_PACKAGE_VERSION "${BALL_PACKAGE_VERSION_MAJOR}.${BALL_PACKAGE_VERSION_MINOR}.${BALL_PACKAGE_VERSION_PATCH}" CACHE INTERNAL "BALL VERSION" FORCE)

# Initialize the various PREFIX variables. This has to happen before any files
# using them are included.
#SET(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "Installation prefix for BALL")

## default build type (for Makefile generators): Release
## TODO: 64 Bit builds etc for Windows
IF(BALL_BUILD_TYPE)
	MESSAGE(WARNING "The BALL_BUILD_TYPE should no longer be used. Use CMAKE_BUILD_TYPE instead")
	SET(CMAKE_BUILD_TYPE ${BALL_BUILD_TYPE})
ENDIF()

SET(BALL_CONTRIB_PATH "" CACHE PATH "Path to the contrib directory, if installed (optional)")
SET(CMAKE_PREFIX_PATH ${BALL_CONTRIB_PATH} ${CMAKE_PREFIX_PATH})

SET(CMAKE_REQUIRED_INCLUDES ${BALL_CONTRIB_PATH}/include ${CMAKE_REQUIRED_INCLUDES})

SET(BALL_TEST_DATA_PATH ${PROJECT_SOURCE_DIR}/source/TEST/data)
SET(BALL_BENCHMARK_DATA_PATH ${PROJECT_SOURCE_DIR}/source/BENCHMARKS/data)

# Should we build packages as well?
OPTION(BALL_ENABLE_PACKAGING "Enable the building of binary packages" OFF)

# Used for linking BALL dependent applications and libraries (BALLView, Python bindings, ...)
SET(BALL_LIBRARIES optimized BALL debug BALLd)
SET(VIEW_LIBRARIES optimized VIEW debug VIEWd)

# some of our own macros (BALL_CHECKLIB, QT4_WRAP_UI_OWN, ...)
INCLUDE(cmake/BALLMacros.cmake)
INCLUDE(cmake/BALLCompilerSpecific.cmake)
INCLUDE(cmake/BALLConfiguration.cmake)
INCLUDE(cmake/BALLComponents.cmake)

## additional include directories
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include/) ## for configured files, i.e. config.h
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include/)
IF (BALL_CONTRIB_PATH)
	INCLUDE_DIRECTORIES(${BALL_CONTRIB_PATH}/include/)
ENDIF()

## Extra libraries we want to link into BALL
SET(BALL_DEP_LIBRARIES)
SET(VIEW_DEP_LIBRARIES)

## Flex and Bison
## This ugly hack is required as long as we cannot tell cmake to set an environment variable for bison...
IF (WIN32)
	FIND_PROGRAM(BISON_EXECUTABLE BALL-bison.bat DOC "path to the bison executable")
ENDIF()
FIND_PACKAGE(BISON)
IF (NOT BISON_FOUND)
	MESSAGE(SEND_ERROR "Could not find bison parser generator!")
ENDIF()

IF (WIN32)
	SET(BALL_BISON_BAT ${BISON_EXECUTABLE})
	SET(BISON_EXECUTABLE "call")
ENDIF()

FIND_PACKAGE(FLEX)
IF (NOT FLEX_FOUND)
	MESSAGE(SEND_ERROR "Could not find flex scanner generator!")
ENDIF()

## Third-party libraries ##

## XDR related stuff
FIND_PACKAGE(XDR)
IF (XDR_FOUND)
	INCLUDE(cmake/BALLConfigXDR.cmake)
ENDIF()

## Boost and Asio
INCLUDE(cmake/BALLConfigBoost.cmake)
INCLUDE_DIRECTORIES(${BOOST_INCLUDE_DIRS})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
LIST(APPEND BALL_DEP_LIBRARIES ${BOOST_LIBRARIES})
# make the rest of CMake aware of boost's existence
LIST(APPEND CMAKE_REQUIRED_INCLUDES ${BOOST_INCLUDE_DIRS})

## Find a suitable hash map implementation (or fall back to map)
INCLUDE(cmake/BALLConfigHashMap.cmake)

## GSL
FIND_PACKAGE(GSL)
IF (NOT GSL_FOUND)
	MESSAGE(SEND_ERROR "gsl is required for BALL but could not be found!")
ELSE()
	ADD_DEFINITIONS(${CMAKE_GSL_CXX_FLAGS})
	INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIR})
	LIST(APPEND BALL_DEP_LIBRARIES ${GSL_LIBRARIES})
ENDIF()

## BLAS
FIND_PACKAGE(BLAS)
IF (BLAS_FOUND)
	SET(BALL_HAS_BLAS TRUE)
	INCLUDE_DIRECTORIES(${BLAS_INCLUDE_DIR})
	LIST(APPEND BALL_DEP_LIBRARIES ${BLAS_LIBRARIES})
ENDIF()

## LAPACK
FIND_PACKAGE(LAPACK)
IF (LAPACK_FOUND)
	SET(BALL_HAS_LAPACK TRUE)
	INCLUDE_DIRECTORIES(${LAPACK_INCLUDE_DIR})
	LIST(APPEND BALL_DEP_LIBRARIES ${LAPACK_LIBRARIES})
ENDIF()

## FFTW
OPTION(USE_FFTWD "Use double precision FFTW if found" ON)
OPTION(USE_FFTWF "Use single precision FFTW if found" ON)
OPTION(USE_FFTWF "Use long double precision FFTW if found" ON)
OPTION(USE_FFTW_THREADS "Try to find FFTW with thread support" OFF)

FIND_PACKAGE(FFTW)
IF(FFTW_FOUND)
	INCLUDE(cmake/BALLConfigFFTW.cmake)
ENDIF()

#Set the default complex precision to float if the setting for this value
#could not be determined earlier
IF(NOT BALL_COMPLEX_PRECISION)
	SET(BALL_COMPLEX_PRECISION "float")
ENDIF()

## lpsolve
OPTION(USE_LPSOLVE "Compile with lpsolve support, if lpsolve can be found" ON)

FIND_PACKAGE(LPSolve)
IF (LPSOLVE_FOUND)
	SET(BALL_HAS_LPSOLVE TRUE)
	INCLUDE_DIRECTORIES(${LPSOLVE_INCLUDE_DIR})
ENDIF()

## VRPN
FIND_PACKAGE(VRPN)
IF (VRPN_FOUND)
	SET(BALL_HAS_VRPN TRUE)
	INCLUDE_DIRECTORIES(${VRPN_INCLUDE_DIR})
ENDIF()

## libsvm
OPTION(USE_LIBSVM "Compile with libsvm support if libsvm can be found" ON)

FIND_PACKAGE(libSVM)
IF (LIBSVM_FOUND)
	SET(BALL_HAS_LIBSVM TRUE)
	INCLUDE_DIRECTORIES(${LIBSVM_INCLUDE_DIRS})
ENDIF()

## CUDA
SET(MT_ENABLE_CUDA OFF CACHE BOOL "Should CUDA support be enabled (version <= 2.1 currently supported).")

IF(MT_ENABLE_CUDA)
	FIND_PACKAGE(CUDA REQUIRED)
ENDIF()

## TBB
SET(MT_ENABLE_TBB OFF CACHE BOOL "Should Intel Threading Building Blocks support be enabled.")

IF(MT_ENABLE_TBB)
	FIND_PACKAGE(TBB REQUIRED)
	INCLUDE_DIRECTORIES(${TBB_INCLUDE_DIRS})
	BALL_COMBINE_LIBS(TBB_LIBRARIES "${TBB_LIBRARIES}" "${TBB_DEBUG_LIBRARIES}")
ENDIF()

## MPI
OPTION(MT_ENABLE_MPI "Should MPI support be enabled.")

IF (MT_ENABLE_MPI)
	FIND_PACKAGE(MPI REQUIRED)

	ADD_DEFINITIONS(${MPI_COMPILE_FLAGS})
	INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})

	SET(BALL_HAS_MPI TRUE)
ENDIF()

## VIEW related options/settings/libraries
OPTION(BALL_HAS_VIEW "Compile BALL's VIEW library required for visualization and graphical user interfaces" ON)

## QT
OPTION(BALL_HAS_QTSQL "Compile BALL's database adapaters (requires QtSql)" ON)

FIND_PACKAGE(Qt4 REQUIRED)

SET(QT_USE_QTXML TRUE)
SET(QT_USE_QTNETWORK TRUE)
SET(QT_USE_QTSQL ${BALL_HAS_QTSQL})
SET(QT_USE_QTOPENGL TRUE)
SET(QT_USE_QTTEST TRUE)
SET(QT_MIN_VERSION "4.4.0")

IF (NOT BALL_HAS_VIEW)
	SET(QT_DONT_USE_QTGUI TRUE)
ENDIF()

INCLUDE(${QT_USE_FILE})

MESSAGE(STATUS "QT qmake at ${QT_QMAKE_EXECUTABLE}")
MESSAGE(STATUS "QT moc at ${QT_MOC_EXECUTABLE}")
MESSAGE(STATUS "QT uic at ${QT_UIC_EXECUTABLE}")

## VIEW dependent packages
IF (BALL_HAS_VIEW)

	## OpenGL
	FIND_PACKAGE(OpenGL)
	IF (NOT OPENGL_FOUND OR NOT OPENGL_GLU_FOUND)
		MESSAGE(SEND_ERROR "Could not find gl/glu!")
	ENDIF()

	## GLEW
	FIND_PACKAGE(GLEW)
	IF (GLEW_FOUND)
		SET(BALL_HAS_GLEW TRUE)
	ENDIF()

ENDIF(BALL_HAS_VIEW)

## Python
OPTION(BALL_PYTHON_SUPPORT "Compile BALL's python interface (requires python development packages)" ON)

IF (BALL_PYTHON_SUPPORT)
	FIND_PACKAGE(PythonInterp)
	IF (PYTHONINTERP_FOUND)
		FIND_PACKAGE(PythonLibs)
		IF (PYTHONLIBS_FOUND)
			BALL_COMBINE_LIBS(PYTHON_LIBRARIES "${PYTHON_LIBRARIES}" "${PYTHON_DEBUG_LIBRARIES}")
			FIND_PACKAGE(SIP)
			SET(BALL_SIP_VERSION ${SIP_VERSION})
			SET(BALL_SIP_VERSION_STR ${SIP_VERSION_STR})
		ENDIF()
	ENDIF()

	IF (NOT PYTHONINTERP_FOUND OR NOT PYTHONLIBS_FOUND OR NOT SIP_FOUND)
		SET(BALL_PYTHON_SUPPORT OFF)
		MESSAGE(WARNING "Disabling python support.")
	ELSE()
		INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
		INCLUDE_DIRECTORIES(${SIP_INCLUDE_DIR})
	ENDIF()
ENDIF()

## On Windows, we might need a seperate regex2-lib
IF (WIN32)
	IF (NOT BALL_HAS_BOOST_REGEX)
		FIND_LIBRARY(REGEX_LIBRARIES
			NAMES regex2 regex
			PATH_SUFFIXES lib dlls
			DOC "Regular expressions library")

		IF (NOT REGEX_LIBRARIES)
			MESSAGE(SEND_ERROR "Could not find required regex2.lib!")
		ENDIF()
	ELSE()
		SET(REGEX_LIBRARIES "")
	ENDIF()
ENDIF()


OPTION(BALL_BUILD_QUEASY "Build BALL with QSAR frontends" OFF)

IF (BALL_BUILD_QUEASY)
	FIND_PACKAGE(Qwt5 REQUIRED)
	
	SET(QWT_LIBRARIES ${Qwt5_Qt4_LIBRARY})
ENDIF ()

## replace any variables in config.h.in with current values
SET(CONFIGURED_CONFIG_H ${PROJECT_BINARY_DIR}/include/BALL/CONFIG/config.h)
CONFIGURE_FILE(cmake/config.h.in ${CONFIGURED_CONFIG_H})
	
## automatically create the version numbers
CONFIGURE_FILE(cmake/templates/version.h.in ${PROJECT_BINARY_DIR}/include/BALL/COMMON/version.h)
CONFIGURE_FILE(cmake/templates/BALL.doc.in  ${PROJECT_SOURCE_DIR}/include/BALL/BALL.doc)

## build a config.h file for the python support to not disturb the
## rest of BALL
CONFIGURE_FILE(cmake/BALLPythonConfig.h.in ${PROJECT_BINARY_DIR}/include/BALL/PYTHON/BALLPythonConfig.h)

## build a config.h file for our tests to not disturb the rest of BALL
CONFIGURE_FILE(cmake/BALLTestConfig.h.in ${PROJECT_BINARY_DIR}/source/TEST/BALLTestConfig.h)

## build a config.h file for our benchmarks to not disturb the rest of BALL
CONFIGURE_FILE(cmake/BALLBenchmarkConfig.h.in ${PROJECT_BINARY_DIR}/source/BENCHMARKS/BALLBenchmarkConfig.h)

ADD_DEFINITIONS(${BALL_DEFINITIONS})

SET(BALL_EXECUTABLES "")
########################################################
###    BUILD the lib																 ###
########################################################

## are we building a shared or static lib?! (BOTH within 
## the same BUILD-tree is NOT possible currently!!)
SET(BUILD_SHARED_LIBS TRUE)

SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

## These variables are used in all install-targets
IF (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET(BALL_RUNTIME_INSTALL_DIRECTORY "bin")
	SET(BALL_LIBRARY_INSTALL_DIRECTORY "lib")
	SET(BALL_ARCHIVE_INSTALL_DIRECTORY "lib")
	SET(BALL_HEADER_INSTALL_DIRECTORY   ".")
	SET(BALL_DATA_INSTALL_DIRECTORY    "share/BALL")
	SET(BALL_DOCUMENTATION_INSTALL_DIRECTORY    "share/BALL/doc")
	IF(WIN32)
		SET(BALL_PYTHON_INSTALL_DIRECTORY  "bin")
		SET(BALL_PLUGIN_INSTALL_DIRECTORY  "bin")
	ELSE()
		SET(BALL_PYTHON_INSTALL_DIRECTORY  "lib")
		SET(BALL_PLUGIN_INSTALL_DIRECTORY  "lib")
	ENDIF()
ELSE()
	SET(BALL_BUNDLE_INSTALL_DIRECTORY  					"Applications")
	SET(BALL_RUNTIME_INSTALL_DIRECTORY 					"Applications/BALLView.app/Contents/Frameworks")
	SET(BALL_LIBRARY_INSTALL_DIRECTORY 					"Applications/BALLView.app/Contents/Frameworks")
	SET(BALL_ARCHIVE_INSTALL_DIRECTORY 					"Applications/BALLView.app/Contents/Frameworks")
	SET(BALL_DATA_INSTALL_DIRECTORY    					"Applications/BALLView.app/Contents/Resources")
	SET(BALL_DOCUMENTATION_INSTALL_DIRECTORY    "Applications/BALLView.app/Contents/Resources/doc")

=== source/EXTENSIONS/CMakeLists.txt ===
IF (USE_SPNAV)
	ADD_SUBDIRECTORY(SPACENAV)
ENDIF()

=== source/TEST/CMakeLists.txt ===
### Build rules for BALL's class tests
PROJECT("BALL_tests")

ENABLE_TESTING()

OPTION(BALL_TEST_VERBOSE "Use verbose output for the tests" ON)

SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/TEST)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

## For now, disable optimization for the tests
IF (CMAKE_COMPILER_IS_INTELCXX OR CMAKE_COMPILER_IS_GNUCXX)
	SET(CMAKE_CXX_FLAGS_RELEASE_SAVED ${CMAKE_CXX_FLAGS_RELEASE})
	SET(CMAKE_CXX_FLAGS_RELEASE "-O0")
ENDIF()

INCLUDE(cmake/BALLTestExecutables.cmake)
INCLUDE(cmake/VIEWTestExecutables.cmake)

## BASIC
ADD_CUSTOM_TARGET(BASIC_TEST)
ADD_DEPENDENCIES(BASIC_TEST ${BALL_BASIC_TESTS})

## MATHS
ADD_CUSTOM_TARGET(MATHS_TEST)
ADD_DEPENDENCIES(MATHS_TEST ${BALL_MATHS_TESTS})

## SYSTEM
ADD_CUSTOM_TARGET(SYSTEM_TEST)
ADD_DEPENDENCIES(SYSTEM_TEST ${BALL_SYSTEM_TESTS})

## TODO: all of them...

## Restore build flags
IF (CMAKE_COMPILER_IS_INTELCXX OR CMAKE_COMPILER_IS_GNUCXX)
	SET(${CMAKE_CXX_FLAGS_RELEASE} ${CMAKE_CXX_FLAGS_RELEASE_SAVED})
ENDIF()

SET(BALLTEST_SUPPORT_LIBRARIES "")
IF (UNIX)
	LIST(APPEND BALLTEST_SUPPORT_LIBRARIES "pthread")
ENDIF ()

# Now, add all tests as targets
SET(ALL_TESTS "")
FOREACH(group ${BALL_TESTS})
	FOREACH(test ${${group}})
		IF (WIN32)
			# Workaround for the stupid MSVC
			ADD_EXECUTABLE(${test} ${test}.C stringStub.C)
		ELSE()
			ADD_EXECUTABLE(${test} ${test}.C)
		ENDIF()
		TARGET_LINK_LIBRARIES(${test} BALL ${BALLTEST_SUPPORT_LIBRARIES})
		SET_PROPERTY(TARGET ${test} PROPERTY FOLDER ${group})
		IF (NOT BALL_TEST_VERBOSE)
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test})
		ELSE()
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test} "-v")
		ENDIF()
		LIST(APPEND ALL_TESTS ${test})
	ENDFOREACH()
ENDFOREACH()

IF (BALL_HAS_VIEW)
	FOREACH(test ${VIEW_TESTS})
		IF (WIN32)
			# Workaround for the stupid MSVC
			ADD_EXECUTABLE(${test} ${test}.C stringStub.C)
		ELSE()
			ADD_EXECUTABLE(${test} ${test}.C)
		ENDIF()
		TARGET_LINK_LIBRARIES(${test} BALL VIEW ${BALLTEST_SUPPORT_LIBRARIES})
		SET_PROPERTY(TARGET ${test} PROPERTY FOLDER BALL_VIEW_TESTS)
		IF (NOT BALL_TEST_VERBOSE)
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test})
		ELSE()
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test} "-v")
		ENDIF()
	ENDFOREACH()

	LIST(APPEND ALL_TESTS ${VIEW_TESTS})
ENDIF()

# Create a suitable target
ADD_CUSTOM_TARGET(build_tests)
ADD_DEPENDENCIES(build_tests ${ALL_TESTS})

=== source/APPLICATIONS/BALLVIEW/CMakeLists.txt ===
PROJECT(BALLView)

### list all filenames of the directory here ###
SET(SOURCES_LIST
	demoTutorialDialog.C
	icons.C
	main.C
	mainframe.C
)

### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	demoTutorialDialog.h
	mainframe.h
)

SET(UI_SOURCES_LIST
	aboutDialog.ui
	demoTutorialDialog.ui
)

SET(RCC_SOURCES_LIST
	splashscreen.qrc
)

SET(RESOURCES_LIST
	BALLView.rc
)

IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF()

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_EXECUTABLE(BALLView
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
	${RESOURCES_LIST}
)

IF (WIN32)
	SET_TARGET_PROPERTIES(BALLView PROPERTIES WIN32_EXECUTABLE TRUE)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET_TARGET_PROPERTIES(BALLView PROPERTIES MACOSX_BUNDLE TRUE)
ENDIF()

INSTALL(TARGETS BALLView
	COMPONENT "${COMPONENT_BALLVIEW}"
	RUNTIME DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
	BUNDLE DESTINATION "${BALL_BUNDLE_INSTALL_DIRECTORY}"
)

INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/internal 
	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
	COMPONENT "${COMPONENT_BALLVIEW}"
)

INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/BALLView 
	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
	COMPONENT "${COMPONENT_BALLVIEW}"
)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	GET_FILENAME_COMPONENT(MACDEPLOYQT_EXECUTABLE "${QT_QMAKE_EXECUTABLE}" PATH)
	SET(MACDEPLOYQT_EXECUTABLE "${MACDEPLOYQT_EXECUTABLE}/macdeployqt")
	INSTALL(CODE "SET(MACDEPLOYQT_EXECUTABLE \"${MACDEPLOYQT_EXECUTABLE}\")" COMPONENT "${COMPONENT_BALLVIEW}")
	INSTALL(CODE "SET(FIXBUNDLE ${CMAKE_SOURCE_DIR}/MacOSX/fixbundleframeworks.sh)" COMPONENT "${COMPONENT_BALLVIEW}")
	INSTALL(CODE "SET(BALLVIEW_BUNDLE \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${BALL_BUNDLE_INSTALL_DIRECTORY}/BALLView.app\")" COMPONENT "${COMPONENT_BALLVIEW}")
	INSTALL(CODE "SET(CMAKE_SOURCE_DIR ${CMAKE_SOURCE_DIR})" COMPONENT "${COMPONENT_BALLVIEW}")
	INSTALL(SCRIPT "${CMAKE_SOURCE_DIR}/cmake/BALLViewCreateBundle.cmake" COMPONENT "${COMPONENT_BALLVIEW}")
ENDIF()

SET(BALLVIEW_SUPPORT_LIBRARIES "")
IF (UNIX)
	LIST(APPEND BALLVIEW_SUPPORT_LIBRARIES "pthread")
ENDIF ()

TARGET_LINK_LIBRARIES(BALLView BALL VIEW ${BALLVIEW_SUPPORT_LIBRARIES})

#Setup the translations
INCLUDE(${CMAKE_SOURCE_DIR}/cmake/BALLViewTranslations.cmake)

=== source/APPLICATIONS/QuEasyRun/CMakeLists.txt ===
PROJECT(QueEasyRun)

### list all filenames of the directory here ###
SET(SOURCES_LIST
#	featureSelector.C
#	inputPartitioner.C
#	inputReader.C
	main.C
#	modelCreator.C
#	predictor.C
#	validator.C
)

IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
# TODO: Use an icon for QuEasy
	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF()

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(-DEXT_MAIN)

ADD_EXECUTABLE(QuEasyRun
	${SOURCES_LIST}
	${RESOURCES_LIST}
)

IF (WIN32)
	SET_TARGET_PROPERTIES(QuEasyRun PROPERTIES WIN32_EXECUTABLE TRUE)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET_TARGET_PROPERTIES(QuEasyRun PROPERTIES MACOSX_BUNDLE TRUE)
ENDIF()

INSTALL(TARGETS QuEasyRun
	COMPONENT "${COMPONENT_QUEASY}"
	RUNTIME DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
	BUNDLE DESTINATION "${BALL_BUNDLE_INSTALL_DIRECTORY}"
)

#INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/QuEasyRun
#	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
#	COMPONENT "${COMPONENT_QUEASY}"
#)

#INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/BALLView 
#	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
#	COMPONENT "${COMPONENT_BALLVIEW}"
#)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	GET_FILENAME_COMPONENT(MACDEPLOYQT_EXECUTABLE "${QT_QMAKE_EXECUTABLE}" PATH)
	SET(MACDEPLOYQT_EXECUTABLE "${MACDEPLOYQT_EXECUTABLE}/macdeployqt")
	INSTALL(CODE "SET(MACDEPLOYQT_EXECUTABLE \"${MACDEPLOYQT_EXECUTABLE}\")" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(FIXBUNDLE ${CMAKE_SOURCE_DIR}/MacOSX/fixbundleframeworks.sh)" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(BALLVIEW_BUNDLE \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${BALL_BUNDLE_INSTALL_DIRECTORY}/QuEasyRun.app\")" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(CMAKE_SOURCE_DIR ${CMAKE_SOURCE_DIR})" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(SCRIPT "${CMAKE_SOURCE_DIR}/cmake/BALLViewCreateBundle.cmake" COMPONENT "${COMPONENT_QUEASY}")
ENDIF()

TARGET_LINK_LIBRARIES(QuEasyRun BALL VIEW)

=== source/APPLICATIONS/QuEasyViz/CMakeLists.txt ===
PROJECT(QuEasyViz)

INCLUDE_DIRECTORIES(. ${Qwt5_INCLUDE_DIR})

### list all filenames of the directory here ###
SET(SOURCES_LIST
	bayesPlotter.C
	coefficientPlotter.C
	componentPlotter.C
	connectionManager.C
	CSVInputDataItem.C
	CSVInputDialog.C
	dataItem.C
	dataItemScene.C
	dataItemView.C
	dottedEdge.C
	edge.C
	exception.C
	featurePlotter.C
	featureSelectionDialog.C
	featureSelectionItem.C
	fileBrowser.C
	inputDataDialog.C
	inputDataItem.C
	inputDataItemIO.C
	inputPartitionItem.C
	inputPlotter.C
	main.C
	mainWindow.C
	modelConfigurationDialog.C
	modelConfigurationDialogPages.C
	modelItem.C
	partitioningItem.C
	pipeline.C
	plotter.C
	predictionItem.C
	predictionPlotter.C
	predictionResultDialog.C
	SDFInputDataItem.C
	SDFInputDialog.C
	validationDialog.C
	validationItem.C
	validationResultDialog.C
)

### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	componentPlotter.h
	connectionManager.h
	CSVInputDialog.h
	dataItem.h
	dataItemScene.h
	dataItemView.h
	featurePlotter.h
	featureSelectionDialog.h
	inputDataDialog.h
	inputDataItem.h
	inputPlotter.h
	mainWindow.h
	modelConfigurationDialog.h
	modelConfigurationDialogPages.h
	modelItem.h
	plotter.h
	predictionItem.h
	predictionResultDialog.h
	SDFInputDialog.h
	validationDialog.h
	validationItem.h
	validationResultDialog.h
)

#SET(RESOURCES_LIST
#	QuEasyViz.rc
#)

IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	# TODO: use individual icon for QuEasy
	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF()

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
#QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
#QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

IF (NOT Qwt5_Qt4_LIBRARY)
	MESSAGE(SEND_ERROR "Could not find Qwt5 library linked against Qt4!")
ENDIF()

ADD_EXECUTABLE(QuEasyViz
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
	${RESOURCES_LIST}
)

IF (WIN32)
	SET_TARGET_PROPERTIES(QuEasyViz PROPERTIES WIN32_EXECUTABLE TRUE)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET_TARGET_PROPERTIES(QuEasyViz PROPERTIES MACOSX_BUNDLE TRUE)
ENDIF()

INSTALL(TARGETS QuEasyViz
	COMPONENT "${COMPONENT_QUEASY}"
	RUNTIME DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
	BUNDLE DESTINATION "${BALL_BUNDLE_INSTALL_DIRECTORY}"
)

#INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/QuEasyViz 
#	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
#	COMPONENT "${COMPONENT_QUEASY}"
#)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	GET_FILENAME_COMPONENT(MACDEPLOYQT_EXECUTABLE "${QT_QMAKE_EXECUTABLE}" PATH)
	SET(MACDEPLOYQT_EXECUTABLE "${MACDEPLOYQT_EXECUTABLE}/macdeployqt")
	INSTALL(CODE "SET(MACDEPLOYQT_EXECUTABLE \"${MACDEPLOYQT_EXECUTABLE}\")" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(FIXBUNDLE ${CMAKE_SOURCE_DIR}/MacOSX/fixbundleframeworks.sh)" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(BALLVIEW_BUNDLE \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${BALL_BUNDLE_INSTALL_DIRECTORY}/QuEasyViz.app\")" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(CODE "SET(CMAKE_SOURCE_DIR ${CMAKE_SOURCE_DIR})" COMPONENT "${COMPONENT_QUEASY}")
	INSTALL(SCRIPT "${CMAKE_SOURCE_DIR}/cmake/BALLViewCreateBundle.cmake" COMPONENT "${COMPONENT_QUEASY}")
ENDIF()

TARGET_LINK_LIBRARIES(QuEasyViz BALL VIEW ${Qwt5_Qt4_LIBRARY})

=== source/EXTENSIONS/SPACENAV/CMakeLists.txt ===
PROJECT(SPACENAVIGATOR)

FIND_PACKAGE(SpaceNavigator)

IF(NOT SPNAV_LIBRARY)
	MESSAGE(SEND_ERROR "Could not find SpaceNavigator libraries")
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(SOURCES_LIST
	${DIRECTORY}/spaceNavigatorDriver.C
	${DIRECTORY}/spaceNavigatorPlugin.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/spaceNavigatorPlugin.h
)
#IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
#	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
#	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
#	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
#			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
#ENDIF()


QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginSpaceNavigator SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginSpaceNavigator PROPERTIES PREFIX "")

INSTALL(TARGETS pluginSpaceNavigator
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginSpaceNavigator BALL VIEW ${SPNAV_LIBRARY})

=== source/MATHS/LINALG/CMakeLists.txt ===
if(USE_lapack)
	list(APPEND BALL_SOURCES 
		MATHS/LINALG/eigenSolver.C
		MATHS/LINALG/linalgException.C
		MATHS/LINALG/matrix.C
		MATHS/LINALG/SVDSolver.C
		MATHS/LINALG/vector.C
	)
endif(USE_lapack)

=== source/PYTHON/EXTENSIONS/CMakeLists.txt ===
PROJECT(BALLPython)

IF(BALL_PYTHON_SUPPORT)
	INCLUDE(SIPMacros)

	REMOVE_DEFINITIONS(-pedantic)

	INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})

	IF(NOT BALL_HAS_ASIO)
		SET(SIP_DISABLE_FEATURES "BALL_HAS_ASIO")
	ENDIF()
	SET(SIP_EXTRA_OPTIONS "-e")

	FILE(GLOB BALL_SIP_DEPENDS "BALL/*.sip")
	FILE(GLOB VIEW_SIP_DEPENDS "VIEW/*.sip")

	SET(SIP_EXTRA_FILES_DEPEND ${BALL_SIP_DEPENDS} ${VIEW_SIP_DEPENDS})

	# Add the BALLCore python bindings
	SET(SIP_EXTRA_SOURCES 
		BALL/pyBALLSipHelper.C
		BALL/pyIndexList.C
		BALL/pyConstant.C
	)
	ADD_SIP_PYTHON_MODULE(BALLCore BALLCoremodule BALL/BALLCore.sip BALL)
	
	IF(BALL_HAS_VIEW)
		SET(SIP_EXTRA_SOURCES
			VIEW/pyCompositeList.C
			VIEW/pyBALLSipHelper.C
			VIEW/pyColorRGBAVector.C
			VIEW/pyDatasetVector.C
		)
		# Add the VIEW python bindings
		SET(SIP_INCLUDES ${PROJECT_SOURCE_DIR})
		ADD_SIP_PYTHON_MODULE(VIEW VIEWmodule VIEW/VIEW.sip BALL VIEW)
	ENDIF()

	# Install the BALL.py script
	IF(NOT WIN32)
		SET(BALL_PY_LOCATION ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
	ELSE()
		SET(BALL_PY_LOCATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR})

	ENDIF()

	ADD_CUSTOM_COMMAND(TARGET BALLCoremodule POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/BALL.py ${BALL_PY_LOCATION}
	)

	INSTALL(TARGETS BALLCoremodule
		COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
		RUNTIME DESTINATION ${BALL_RUNTIME_INSTALL_DIRECTORY}
		LIBRARY DESTINATION ${BALL_LIBRARY_INSTALL_DIRECTORY}
	)

	IF(BALL_HAS_VIEW)
		INSTALL(TARGETS VIEWmodule
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_VIEW}"
			RUNTIME DESTINATION ${BALL_RUNTIME_INSTALL_DIRECTORY}
			LIBRARY DESTINATION ${BALL_LIBRARY_INSTALL_DIRECTORY}
		)
	ENDIF()

	INSTALL(FILES ${PROJECT_SOURCE_DIR}/BALL.py 
		COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
		DESTINATION "${BALL_PYTHON_INSTALL_DIRECTORY}"
	)
	
	IF (WIN32)
		INSTALL(FILES ${PYTHON_EXECUTABLE}
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
		)
		
		GET_FILENAME_COMPONENT(PYTHON_SITE_PACKAGES_DIR ${PYTHON_EXECUTABLE} PATH) 
		SET(PYTHON_SITE_PACKAGES_DIR "${PYTHON_SITE_PACKAGES_DIR}/lib")
		
		INSTALL(DIRECTORY "${PYTHON_SITE_PACKAGES_DIR}"
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
		)
	ENDIF ()

	IF (APPLE)
		INSTALL(FILES ${SIP_LIBRARIES}
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			DESTINATION "${BALL_PYTHON_INSTALL_DIRECTORY}"
		)
	ENDIF()

ENDIF()

=== debian/changelog ===
ball (1.4.1+20111206-4ubuntu2) raring; urgency=low

  * Rebuild against sip-api-9.0.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 07 Nov 2012 09:29:56 +0000

ball (1.4.1+20111206-4ubuntu1) quantal; urgency=low

  * Transition to libglew1.8.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Sat, 08 Sep 2012 13:16:58 +0100

ball (1.4.1+20111206-4) unstable; urgency=low

  * Fix compilation with g++ >= 4.7 (Closes: 674226) 
  * Updated policy to 3.9.3 (no changes required)

 -- Andreas Hildebrandt <andreas.hildebrandt@uni-mainz.de>  Wed, 15 Aug 2012 00:50:32 +0200

ball (1.4.1+20111206-3) unstable; urgency=low

  * Fixed "const" in .sip files (Closes: #653626)

 -- Steffen Moeller <moeller@debian.org>  Fri, 06 Jan 2012 16:43:51 +0100

ball (1.4.1+20111206-2) unstable; urgency=low

  * Added "signed" to char because of platform differences

 -- Steffen Moeller <moeller@debian.org>  Fri, 09 Dec 2011 13:55:01 +0100

ball (1.4.1+20111206-1) unstable; urgency=low

  * New upstream version.
  * Depending on ghostscript, not gs-common (Closes: #649711)

 -- Andreas Hildebrandt <andreas.hildebrandt@uni-mainz.de>  Thu, 08 Dec 2011 19:53:09 +0100

ball (1.4.1-1) UNRELEASED; urgency=low

  * Updated to new upstream release 1.4.1 

 -- Andreas Hildebrandt <andreas.hildebrandt@uni-mainz.de>  Thu, 20 Oct 2011 21:36:03 +0200

ball (1.4.0-5) unstable; urgency=low

   * Added myself to Uploaders
   * Rebuilt with current version of python (Closes: #632488).
   * Added dependency on texlive-latex-recommended and the build
     instructions should already separate the documentation from
     the rest (Closes: #631999).
   * Unsigned char issue was at some point already fixed (Closes: #631998).

 -- Steffen Moeller <moeller@debian.org>  Fri, 22 Jul 2011 17:17:06 +0200

ball (1.4.0-4) UNRELEASED; urgency=low

  * Documentation packages are in conflict (Closes: #631911)
  * Removed (redundant) conflict of ballview to itself
  * Helped quirk in descrition (Closes: #598081)

 -- Andreas or Steffen  <moeller@debian.org>  Thu, 21 Jul 2011 17:55:28 +0200
    

=== debian/control ===
Source: ball
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Andreas Hildebrandt <andreas.hildebrandt@uni-mainz.de>
Build-Depends: debhelper (>= 5), 
 qt4-dev-tools, libqt4-dev, libqt4-gui, libqt4-opengl,
 libqt4-opengl-dev, libqt4-sql, libqt4-network, 
 python-sip-dev (>= 4.8.2), flex, bison, cmake, libglew-dev, 
 libfftw3-dev, libgsl0-dev, python-dev (>= 2.4), libxrender-dev,
 libboost-dev, libboost-iostreams-dev, libboost-thread-dev, 
 libboost-math-dev | libboost-dev (<< 1.37), libboost-system-dev | libboost-dev (<< 1.37),
 libasio-dev, libboost-regex-dev, libxmu-dev, tidy,
 ghostscript, graphviz, chrpath, python-support (>= 0.90.0)
Build-Depends-Indep: texlive-fonts-recommended,
 doxygen-latex|doxygen, doxygen-latex|latex-xcolor,
 doxygen-latex|texlive-extra-utils, doxygen-latex|texlive-latex-extra
XS-Python-Version: all
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/git/debian-med/ball.git
Vcs-Browser: http://git.debian.org/?p=debian-med/ball.git
Homepage: http://www.ballview.org

Package: libball1.4-data
Section: science
Architecture: all
Depends: ${misc:Depends}
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the data files (force field parameters, fragment
 data bases, etc) necessary for using BALL.

Package: libball1.4
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libball1.4-data
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view - independent parts of BALL (libBALL,
 data directories et al., except for libVIEW) and can be installed on
 machines without X11.

Package: libball1.4-dev
Section: libdevel
Architecture: any
Depends: libball1.4 (= ${binary:Version}), ${misc:Depends}
Conflicts: libball1.3-dev
Suggests: libball1.4-doc
Description: Header files for the Biochemical Algorithms Library
 This package comprises the header files allowing to create
 one's own applications with the BALL library.

Package: libballview1.4
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Biochemical Algorithms Library, VIEW framework
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view parts of BALL (libVIEW). Those are
 required for molecular visualization and for running BALLView.

Package: libballview1.4-dev
Section: libdevel
Architecture: any
Depends: libballview1.4 (= ${binary:Version}), ${misc:Depends}
Conflicts: libballview1.3-dev
Recommends: libball1.4-doc
Description: Header files for the VIEW part of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package comprises the header files allowing to create one's own 
 applications with the VIEW framework of the BALL library.

Package: python-ball
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, ${sip:Depends}, 
 libball1.4, ${misc:Depends}
Conflicts: python-ball (<< ${binary:Version})
Description: Python bindings for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-independent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: python-ballview
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, ${sip:Depends}, 
 libball1.4, libballview1.4, python-ball (= ${binary:Version}), ${misc:Depends}
Conflicts: python-ballview (<< ${binary:Version})
Description: Python bindings for VIEW-parts of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-dependent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: ballview
Section: science
Architecture: any
Depends: ${shlibs:Depends}, libgl1-mesa-glx|libgl1, libball1.4, libballview1.4, python-ball,
 python-ballview, ${misc:Depends}
Description: free molecular modeling and molecular graphics tool
 BALLView provides fast OpenGL-based visualization of molecular structures, 
 molecular mechanics methods (minimization, MD simulation using the 
 AMBER, CHARMM, and MMFF94 force fields), calculation and visualization 
 of electrostatic properties (FDPB) and molecular editing features.
 .
 BALLView can be considered a graphical user interface on the basis of
 BALL (Biochemical Algorithms Library) with a focus on the most common
 demands of protein chemists and biophysicists in particular.  It is
 developed in the groups of Hans-Peter Lenhof (Saarland University,
 Saarbruecken, Germany) and Oliver Kohlbacher (University of Tuebingen,
 Germany). BALL is an application framework in C++ that has been
 specifically designed for rapid software development in Molecular
 Modeling and Computational Molecular Biology.  It provides an extensive
 set of data structures as well as classes for Molecular Mechanics,
 advanced solvation methods, comparison and analysis of protein
 structures, file import/export, and visualization.

Package: libball1.4-doc
Architecture: all
Section: doc
Depends: libball1.4, ${misc:Depends}
Conflicts: libball1.3-doc
Description: documentation for the BALL library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.

Package: ballview-dbg
Architecture: any
Priority: extra
Section: debug
Depends: python-ballview, ballview, ${misc:Depends}
Description: debug symbols for BALL and VIEW libraries
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.
 .
 This package contains all the extra information on the libraries of
 BALL, BALLView and the Python wrappers to help debuggers like GDB to
 interpret a core dump. This is tremendously useful for debugging and
 maybe even more so for the communication between the user of this
 package and upstream when something goes wrong.

=== debian/watch ===
version=3
opts=uversionmangle=s/-(.*)/+$1/ \
http://ball-www.bioinf.uni-sb.de/Releases/all/BALL-(.*)\.tar\.gz

## ball 1.4.2%2B20140406

=== source/EXTENSIONS/PRESENTABALL/CMakeLists.txt ===
PROJECT(PresentaBALL)

IF(NOT USE_QTWEBKIT)
	MESSAGE(STATUS "QtWebkit support has not been enabled. Disabling the PresentaBALPresentaBALL plugin")
	RETURN()
ENDIF()

SET(DIRECTORY source)
### list all filenames of the directory here ###
SET(UI_SOURCES_LIST
)

SET(SOURCES_LIST
	${DIRECTORY}/PresentaBALLPlugin.C
	${DIRECTORY}/HTMLBasedInterface.C
)

SET(RCC_SOURCES_LIST
	${DIRECTORY}/logo.qrc
)

SET(DIRECTORY include)
### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	${DIRECTORY}/PresentaBALLPlugin.h
	${DIRECTORY}/HTMLBasedInterface.h
)

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)

ADD_LIBRARY(pluginPresentaBALL SHARED
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
)

SET_TARGET_PROPERTIES(pluginPresentaBALL PROPERTIES
	PREFIX ""
)

INSTALL(TARGETS pluginPresentaBALL
	COMPONENT "${COMPONENT_PLUGINS}"
	RUNTIME DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
	LIBRARY DESTINATION "${BALL_PLUGIN_INSTALL_DIRECTORY}"
)

TARGET_LINK_LIBRARIES(pluginPresentaBALL BALL VIEW)
